var g_map;
var g_marker;
var g_targets;
var g_gameOver=false;

var LAMAD_SERVER="../../api/server.php";

var GOOGLE_KEY = "AIzaSyC2YXHpksnAc5JXUEF1M0yFxy9xqWr-XYw";
var GOOGLE_NEAREST_ROADS_SERVER="https://roads.googleapis.com/v1/nearestRoads";


function main() {
	var defaultLocation = {lat: 62, lng: 28};

	g_map= new google.maps.Map(document.getElementById('map'), {
		zoom: 16,
		center: defaultLocation,
		
		// removing unnecessary map elements
		fullscreenControl: false,
		streetViewControl:false,
		zoomControl:false,
		mapTypeControl:false
	});
	
	google.maps.event.addListener(g_map, 'dragstart', function() {
		g_mapHandlerType="user";
	});
	
	var icon={
		url:"images/user.png",
		size:new google.maps.Size(20,20),
		scaledSize:new google.maps.Size(20,20),
		origin:new google.maps.Point(0,0),
		anchor:new google.maps.Point(10,10)
	}
		
	g_marker = new google.maps.Marker({
		position: defaultLocation,
		map: g_map,
		icon: icon,
		zIndex:1
	});
	
		
	var success=initializeGeolocation();
	if(success==false){
		alert("Problem with location!");
	}
	 	
	initControls(); 
}

function animateScores(marker,index,percent){
	var oldIcon=marker.getIcon();
	var url=oldIcon.url;
	
	if(index>5*Math.PI && url!="images/"+percent+".png"){
		url="images/"+percent+".png";
	}
	
	var icon={
		url:url,
		size:new google.maps.Size(30*Math.abs(Math.cos(index)),30),
		scaledSize:new google.maps.Size(30*Math.abs(Math.cos(index)),30),
		origin:new google.maps.Point(0,0),
		anchor:new google.maps.Point(15*Math.abs(Math.cos(index)),15)
	}
	marker.setIcon(icon);
	
	if(index<10*Math.PI){
		setTimeout(function(){
			animateScores(marker,index+=(Math.PI/10),percent);
		},20);
	}
}

function revealAnimation(marker,index){
	marker["visited"]=true;
	
	if(marker["special"]=="winner"){
		handleGameOver();
	}
	
	if(marker["special"]=="fifty"){
		removeHalfUnvisited();
		marker.setOptions({opacity:0});
		playFifty();
		return;
	}else if(marker["special"]=="public"){
		scoreUnvisited();
		marker.setOptions({opacity:0});
		playPublic();
		return;
	}
	
	var oldIcon=marker.getIcon();
	var url=oldIcon.url;
	
	var newUrl="images/wrong.png";
	if(marker["special"]=="winner"){
		newUrl="images/right.png";
	}
	
	if(index>5*Math.PI && url!=newUrl){
		url=newUrl;
		if(marker["special"]=="winner"){
			playRight();
		}else{
			playWrong();
		}
	}
	
	var icon={
		url:url,
		size:new google.maps.Size(30*Math.abs(Math.cos(index)),30),
		scaledSize:new google.maps.Size(30*Math.abs(Math.cos(index)),30),
		origin:new google.maps.Point(0,0),
		anchor:new google.maps.Point(15*Math.abs(Math.cos(index)),15)
	}
	marker.setIcon(icon);
	
	if(index<10*Math.PI){
		setTimeout(function(){
			revealAnimation(marker,index+=(Math.PI/10));
		},20);
	}
}

function initializePoints(difficulty){
	var points=[
		{lat:62.60868431357721,lng:29.73259858115989,special:"winner"},
		{lat:62.60477477249902,lng:29.732512750471415,special:"fifty"},
		{lat:62.60240510311431,lng:29.755687036360086,special:"public"},
		{lat:62.60449832081471,lng:29.727448739851297},
		{lat:62.603708444677224,lng:29.737576761091532},
		{lat:62.604735279558845,lng:29.74633149131614},
		{lat:62.60824994554549,lng:29.74985054954368},
		{lat:62.60667037185691,lng:29.759034433210672},
		{lat:62.60106220652103,lng:29.763411798322977},
		{lat:62.59584803242837,lng:29.758948602522196},
		{lat:62.59734917637417,lng:29.744014062727274},
		{lat:62.60066722537791,lng:29.749507226789774},
		{lat:62.60422186655659,lng:29.762210168684305}
	];
	
	
	//easy 1
	//medium 2
	//hard 3
	var noPoints=10;
	var threshold=150;
	var bbSize=1;
	switch(difficulty){
		case 1:
			noPoints=8;
			threshold=150;
			bbSize=1;
			break;
		case 2:
			noPoints=12;
			bbSize=1.5;
			threshold=180;
			break;
		case 3:
			noPoints=15;
			bbSize=2;
			threshold=200;
			break;
	}
	
	var points=new Array();
	for(var i=0;i<noPoints;i++){
		//1 degree 111 km
		do{
			var lat=g_marker.getPosition().lat()+(bbSize/2)*(Math.random()-0.5)/111;
			var lng=g_marker.getPosition().lng()+(bbSize/2)*(Math.random()-0.5)/(111*Math.cos(degToRad(lat)));
			
			var point={
				lat:lat,
				lng:lng
			}
			switch(i){
				case 0:
					point["special"]="winner";
					break;
				case 1:
					point["special"]="fifty";
					break;
				case 2:
					point["special"]="public";
					break;
				
			}
		}while(distanceToNearestPoint(point,points)<threshold);
		
		
		
		points.push(point);
	}
	
	
	getSnappedPoints(points);
	
}

function distanceToNearestPoint(location,points){
	if(points.length==0){
		return 100000;//infinity
	}
	var minDist=-1;
	for(var i=0;i<points.length;i++){
		var dist=getDistance(location,points[i]);
		if(dist<minDist || minDist==-1){
			minDist=dist;
		}
	}
	return minDist;
}

function drawPoints(points,map){
	g_targets=new Array();
	for(var i=0;i<points.length;i++){
		
		var circleColor='rgb(0,153,204)';
		
		var url="images/target.png";
		if(points[i]["special"]=="public"){
			url="images/public.png";
			circleColor='rgb(102,153,0)';
		}else if(points[i]["special"]=="fifty"){
			url="images/fifty.png";
			circleColor='rgb(102,153,0)';
		}
		
		var icon={
			url:url,
			size:new google.maps.Size(30,30),
			scaledSize:new google.maps.Size(30,30),
			origin:new google.maps.Point(0,0),
			anchor:new google.maps.Point(15,15)
		}
		
		var marker = new google.maps.Marker({
			icon:icon,
            position: points[i],
            title: points[i]["title"],
            map: map
        });
		
		var circle = new google.maps.Circle({
            strokeColor: circleColor,
            strokeOpacity: 0.8,
            strokeWeight: 2,
            fillColor: circleColor,
            fillOpacity: 0.35,
            map: map,
            center: points[i],
            radius: 20
          });
		
		marker["special"]=points[i]["special"];
		
		g_targets.push(marker);
	}
}

function getNearestTarget(){
	var nearest={target:null, dist:-1};
	for(var i=0;i<g_targets.length;i++){
		var dist=getDistance(g_targets[i].getPosition(),g_marker.getPosition());
		if(dist<nearest.dist || nearest.dist==-1){
			nearest.target=g_targets[i];
			nearest.dist=dist;
		}
	}
	return nearest;
}

function getNearestUnvisitedTarget(){
	var nearest={target:null, dist:-1};
	for(var i=0;i<g_targets.length;i++){
		if(g_targets[i].visited!=true){
			var dist=getDistance(g_targets[i].getPosition(),g_marker.getPosition());
			if(dist<nearest.dist || nearest.dist==-1){
				nearest.target=g_targets[i];
				nearest.dist=dist;
			}
		}
	}
	return nearest;
}

function removeHalfUnvisited(){
	var unvisited=getUnvisitedWrongTargets();
	shuffle(unvisited);
	for(var i=0;i<unvisited.length/2;i++){
		revealAnimation(unvisited[i],0);		
	}
}

function scoreUnvisited(){
	var audienceSize=10;
	var knowledgebleAudience=4;
	var scores=new Array();
	
	var unvisited=getUnvisitedTargets();
	shuffle(unvisited);
	for(var i=0;i<audienceSize-knowledgebleAudience;i++){
		var sel=Math.floor(Math.random()*unvisited.length/2);
		if(scores[sel]==null){
			scores[sel]=1;
		}else{
			scores[sel]++;
		}
	}
	for(var i=0;i<unvisited.length;i++){
		if(unvisited[i].special=="winner"){
			if(scores[i]==null){
				scores[i]=0;
			}
			scores[i]+=knowledgebleAudience;
		}
	}
	
	for(var i=0;i<unvisited.length;i++){
		if(scores[i]!=null){
			animateScores(unvisited[i],0,scores[i]*10)
		}
	}
	
	console.log(scores);
}


function getUnvisitedTargetsWithBonus(){
	var unvisited=new Array();
	for(var i=0;i<g_targets.length;i++){
		if(g_targets[i].visited!=true){// && g_targets[i].special!="fifty" && g_targets[i].special!="public"){
			unvisited.push(g_targets[i]);
		}
	}
	return unvisited;
}

function getUnvisitedTargets(){
	var unvisited=new Array();
	for(var i=0;i<g_targets.length;i++){
		if(g_targets[i].visited!=true && g_targets[i].special!="fifty" && g_targets[i].special!="public"){
			unvisited.push(g_targets[i]);
		}
	}
	return unvisited;
}

function getUnvisitedWrongTargets(){
	var unvisited=new Array();
	for(var i=0;i<g_targets.length;i++){
		if(g_targets[i].visited!=true && g_targets[i].special!="winner" && g_targets[i].special!="fifty" && g_targets[i].special!="public"){
			unvisited.push(g_targets[i]);
		}
	}
	return unvisited;
}

var shuffle = function (array) {
	var index = array.length;
	var aux, randomIndex;

	// While there remain elements to shuffle...
	while (0 !== index) {
		// Pick a remaining element...
		randomIndex = Math.floor(Math.random() * index);
		index -= 1;

		// And swap it with the current element.
		aux = array[index];
		array[index] = array[randomIndex];
		array[randomIndex] = aux;
	}

	return array;
};


function handleGameOver(userName){
	g_gameOver=true;
	clearInterval(g_timeCounterInterval);
	
	document.getElementById("largeTime").innerHTML=formatDuration(g_playedTime);
	show("scoreSubmission");
}

function submitScore(){
	if(document.getElementById("userName").value==""){
		alert("Enter your name!");
		return;
	}
	var param={
		"request_type":"whereismopsi_submit_score",
		"name":document.getElementById("userName").value,
		"time":g_playedTime,
		"game_size":g_targets.length
	}
	
	httpPostAsync(LAMAD_SERVER,
		"param="+JSON.stringify(param),
		function(stringOutput){
			//console.log(stringOutput);
			getScores();
		});
}

function getScores(){
	hide("scoreSubmission");
	show("resultsScreen");
	
	var param={
		"request_type":"whereismopsi_get_scores"
	}
	
	httpPostAsync(LAMAD_SERVER,
		"param="+JSON.stringify(param),
		function(stringOutput){
			var obj=JSON.parse(stringOutput);
			document.getElementById("results").innerHTML=formatResults(obj);
		});
}

function closeResults(){
	hide("resultsScreen");
	location.reload();
}

function formatResults(results){
	var html="<div class='large_text'>High Scores</div><table class='table_text'>";
	html+="<tr><th>Name</th><th>Time</th><th>Game Type</th></tr>";
	
	for(var i=0;i<results.length;i++){
		html+="<tr><td>"+results[i]["Name"]+
			"</td><td>"+formatDuration(results[i]["Time"])+
			"</td><td>"+formatGameType(results[i]["GameSize"])+
			"</td></tr>";
	}
	
	html+="</table>";
	
	return html;
}

function formatGameType(gameSize){
	switch (gameSize){
		case '8': return "Easy";
		case '12': return "Medium";
		case '15': return "Hard";
	}
}


function getSnappedPoints(points){
	
	var pointsString=""
	for(var i=0;i<points.length;i++){
		if(i>0){
			pointsString+="|";
		}
		pointsString+=points[i]["lat"]+","+points[i]["lng"];
	}
		
	
	var request=GOOGLE_NEAREST_ROADS_SERVER+"?points="+pointsString+"&key="+GOOGLE_KEY;
	
	httpGetAsync(request,function(stringOutput){
		var obj=JSON.parse(stringOutput);
		console.log(obj);
		
		
		for(var i=0;i<obj["snappedPoints"].length;i++){
			points[obj["snappedPoints"][i]["originalIndex"]]["lat"]=
				obj["snappedPoints"][i]["location"]["latitude"];
				
			points[obj["snappedPoints"][i]["originalIndex"]]["lng"]=
					obj["snappedPoints"][i]["location"]["longitude"];
		}
		
		drawPoints(points,g_map);
		handleMap();
	});
}














