function initializeGeolocation(){
	var geolocation=null;
		
	if(window.navigator && window.navigator.geolocation){
		geolocation=window.navigator.geolocation;
	}
	
	if(geolocation){
		geolocation.getCurrentPosition(onLocationUpdate);
		
		// call onLocationUpdate when sensor gets new location
		g_watch = geolocation.watchPosition(onLocationUpdate,null,{
			enableHighAccuracy:true,
			maximumAge:1000
		});
		
		return true;
	}
	return false;
}
		
function onLocationUpdate(event){
	var newLocation=new google.maps.LatLng(
		event["coords"].latitude, 
		event["coords"].longitude
	);
	
	g_marker.setPosition(newLocation);
	
	if(g_screen==ScreenType.main){
		g_map.setCenter(g_marker.getPosition());
		g_map.setZoom(14);
	}else{
		handleMap();
		
		var nearest=getNearestUnvisitedTarget();
		if(nearest.dist<20){
			revealAnimation(nearest.target,0);
		}
	}
}	



// HELPER

function fakePosition(newPosition){
	//g_marker.setPosition(newPosition);
	onLocationUpdate({coords:{latitude:newPosition.lat(),longitude:newPosition.lng()}});
}

var g_simulationTimeout=null;
function simulatePlaying(){
	var unvisited=getUnvisitedTargetsWithBonus();
	
	shuffle(unvisited);
	
	if(unvisited.length!=0){
		fakePosition(unvisited[0].getPosition());
		if(!g_gameOver){
			g_simulationTimeout=setTimeout(function(){
				simulatePlaying();
			},1000);
		}
	}
}

function stopSimulation(){
	clearTimeout(g_simulationTimeout);
}
